#define PSM_FRAME_SIZE		128
#define PSM_FRAMES_PER_BLOCK	64
#define PSM_BLOCKS_PER_CARD	16
#define PSM_MEMORY_SIZE	\
	(PSM_FRAME_SIZE * PSM_FRAMES_PER_BLOCK * PSM_BLOCKS_PER_CARD)

#define PSM_LEN_READ	140
#define PSM_LEN_WRITE	138
#define PSM_LEN_MAX	140
#define PSM_LEN_CHKSUM	(128 + 2 + 1)	/* data+address+csum */

#define PSM_DIR_PRODUCT		115
#define PSM_TITLE_STRING	92
#define PSM_TITLE_PALETTE	32

#define PSM_NR_PALETTES		16

#define PSM_DIR_RESERVED_H	0xf0
#define PSM_DIR_RESERVED	0xff
#define PSM_DIR_AVAIL		0xa0
#define PSM_DIR_INUSE		0x50

#define PSM_DIR_FREE		0x00
#define PSM_DIR_START		0x01
#define PSM_DIR_CONTINUED	0x02
#define PSM_DIR_END_CHAIN	0x03

struct dir_frame {
	unsigned char dir_type;
	unsigned char dir_unknown[3];
	unsigned char dir_size[4];
	unsigned char dir_next[2];
	unsigned char dir_sig[2];
	char dir_product[PSM_DIR_PRODUCT];
	unsigned char dir_xor;
};

struct title_frame {
	unsigned char title_sig[2];
	unsigned char title_icons;
	unsigned char title_icon_blocks;
	unsigned char title_string[PSM_TITLE_STRING];
	unsigned char title_palette[PSM_TITLE_PALETTE];
};
